## install.sh -- installation script for xlockmore-LinuX-logos
## created 17-Jan-1995 jmk
## autodate: 17-Jan-1995
## autotime: 04:14

xlock_dir="../xlockmore"
new_xlock_dir="xlockmore+"
xbm_dir="bitmaps"

## check for xlockmore-2.4 directory
if [ ! -d ${xlock_dir} ]; then
    ## complain if we couldn't find it
    echo "${0}: cannot find xlock directory \`${xlock_dir}'"
    echo "${0}: you may need to edit this script to fit your installation."
else
    ## found it
    ## check if we can write to the bitmap directory
    if [ ! -w ${xlock_dir}/${xbm_dir} ]; then
        ## complain if we can't
        echo "${0}: cannot write to xlock directory \`${xlock_dir}/${xbm_dir}'"
	echo "${0}: you may need to change permissions to install."
    else
        ## we're clear to install
        echo -n "${0}: installing in \`${xlock_dir}/${xbm_dir}' ... "
        for i in image life maze; do
	    ## rename original
            mv ${xlock_dir}/${xbm_dir}/$i-x11.xbm \
	       ${xlock_dir}/${xbm_dir}/$i-x11-orig.xbm
	    ## make symbolic link to here in place of original
            ln -s ../../${new_xlock_dir}/${xbm_dir}/$i-linux.xbm \
	                    ${xlock_dir}/${xbm_dir}/$i-x11.xbm
        done
	echo "Done."
    fi
fi

## that's all!
